from gpiozero import DigitalOutputDevice, Button
from time import sleep

# GPIO-Pins für die Zeilen und Spalten definieren
rows = [17, 27, 22, 5]   # GPIO-Pins für die Zeilen (Anpassen je nach Verkabelung)
columns = [6, 13, 19, 26] # GPIO-Pins für die Spalten (Anpassen je nach Verkabelung)

# Tastenbelegung
key_map = [
    ['1', '2', '3', 'A'],
    ['4', '5', '6', 'B'],
    ['7', '8', '9', 'C'],
    ['*', '0', '#', 'D']
]

# Initialisiere Zeilen als Ausgang (DigitalOutputDevice) und Spalten als Eingänge (Button)
row_pins = [DigitalOutputDevice(pin) for pin in rows]
col_pins = [Button(pin, pull_up=False) for pin in columns]

# Funktion zur Initialisierung der Matrix
def scan_matrix():
    for row_num, row_pin in enumerate(row_pins):
        row_pin.on()  # Aktiviere die aktuelle Zeile
        for col_num, col_pin in enumerate(col_pins):
            if col_pin.is_pressed:
                print(f"Taste {key_map[row_num][col_num]} gedrückt")
        row_pin.off()  # Deaktiviere die aktuelle Zeile
        sleep(0.1)

# Endlose Schleife zur Überprüfung der Tastendrücke
try:
    while True:
        scan_matrix()
        sleep(0.1)  # kurze Pause zwischen den Scans
except KeyboardInterrupt:
    print("Programm beendet.")