from gpiozero import RotaryEncoder, PWMLED
from signal import pause

clk_pin = 17  # CLK (A)
dt_pin = 18   # DT (B)
led_pin = 23  # PWM-fähiger Pin für die LED

encoder = RotaryEncoder(clk_pin, dt_pin, max_steps=10)  # 100 Schritte insgesamt
led = PWMLED(led_pin)

def update_led_brightness():
    brightness = max(0, min(1, encoder.steps / 10))  # Begrenzung auf Werte zwischen 0 und 1
    led.value = brightness
    print(f"Helligkeit: {brightness * 100:.0f}%")

encoder.when_rotated = update_led_brightness

print("Drehen Sie den Rotary Encoder, um die LED-Helligkeit anzupassen.")
pause()