from gpiozero import RotaryEncoder, Button
import matplotlib.pyplot as plt
from matplotlib.animation import FuncAnimation
import time

clk_pin = 17  # CLK (A)
dt_pin = 18   # DT (B)
sw_pin = 4   # Optional: Button Pin

encoder = RotaryEncoder(clk_pin, dt_pin, max_steps=100)
button = Button(sw_pin, pull_up = True, bounce_time= None)

positions = []
times = []

start_time = time.time()

def update_plot(frame):
    current_time = time.time() - start_time
    current_position = encoder.steps
    
    positions.append(current_position)
    times.append(current_time)

    ax.clear()
    ax.plot(times, positions, label='Encoder Position')
    ax.set_xlabel('Zeit (s)')
    ax.set_ylabel('Position (Schritte)')
    ax.legend()

fig, ax = plt.subplots()
ani = FuncAnimation(fig, update_plot, interval=100)
plt.show()